package io.tswf.transmutations.common.conflict

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

interface IConflictResolveStrategyLogic {
    void handleConflictResolve(ConflictResolveContext context)
    ConflictingMethodResolveStrategy getEnumValue()
}

@CheckedMapConstructor
@CompileStatic
class ConflictResolveContext {
    ClassNode targetClass
    MethodNode conflictingMethod

    ClassNode anotherMethodOwner
    MethodNode anotherMethod

    boolean canContinue = false
}