package io.tswf.transmutations.common.conflict.logic

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import groovy.util.logging.Slf4j
import io.tswf.transmutations.common.conflict.ConflictResolveContext
import io.tswf.transmutations.common.conflict.ConflictingMethodResolveStrategy
import io.tswf.transmutations.common.conflict.IConflictResolveStrategyLogic
import io.tswf.transmutations.common.exception.ConflictingMethodFoundException

@AutoService(IConflictResolveStrategyLogic)
@Slf4j
@CompileStatic
class ThrowConflictResolveStrategy implements IConflictResolveStrategyLogic {

    @Override
    void handleConflictResolve(ConflictResolveContext context) {
        throw new ConflictingMethodFoundException(context.targetClass, context.conflictingMethod, context.anotherMethodOwner, context.anotherMethod)
    }

    @Override
    ConflictingMethodResolveStrategy getEnumValue() {
        return ConflictingMethodResolveStrategy.THROW
    }
}
