package io.tswf.transmutations.common.remapping

import org.objectweb.asm.Type
import org.objectweb.asm.commons.Method

interface ITransmutationRemappingStrategy {
    Type mapType(Type anotherType)

    Method mapMethod(Type anotherMethodOwner, Method anotherMethod)
    Tuple2<String, Type> mapField(Type anotherFieldOwner, String anotherFieldName, Type anotherFieldType)
    default String getName() { this.class.name }
    default int getPriority() { 0 }
}