package io.tswf.transmutations.common.remapping

import groovy.transform.CompileStatic
import org.objectweb.asm.Type
import io.tswf.transmutations.common.annotation.ClassReference

@CompileStatic
class PrimitiveClassRemapper {
    public static final Map<Type, Type> PRIMITIVE_MAPPERS = new HashMap<Type, Type>()
            .tap {
                put(ClassReference.BYTE.asAsmType(), byte.class.asAsmType())
                put(ClassReference.SHORT.asAsmType(), short.class.asAsmType())
                put(ClassReference.INT.asAsmType(), int.class.asAsmType())
                put(ClassReference.LONG.asAsmType(), long.class.asAsmType())
                put(ClassReference.FLOAT.asAsmType(), float.class.asAsmType())
                put(ClassReference.DOUBLE.asAsmType(), double.class.asAsmType())
                put(ClassReference.CHAR.asAsmType(), char.class.asAsmType())
                put(ClassReference.BOOLEAN.asAsmType(), boolean.class.asAsmType())
                put(ClassReference.VOID.asAsmType(), void.class.asAsmType())
            }
    
    static Type replacePrimitiveClass(Type type) {
        return PRIMITIVE_MAPPERS[type] ?: type
    }
}
